{#
Using extends instead of normal layout chaining is necessary here as
most of the content is shared between multiple unit test intros for different
programming languages with only a few blocks being distinct.
#}

{% extends "layouts/presentation.njk" %}
{% set source_path = "source/" + language_ + "/" %}
{% set data_path = "/data/" + language_ + "/" %}

{% block presentation %}

{% block language_intro %}{% endblock %}

<section>
  <h2>Structure of a {{ language }} Program</h2>
  <section>
{% highlight language_ %}
{% include source_path + "hello." + language_ %}
{% endhighlight %}
{% include_code source_path + "hello." + language_ %}
  </section>

  <section>
    <h3>Preprocessor Directives</h3>
    <p>Allow to <code>include</code> code declared elsewhere</p>
{% highlight language_ + " 0" %}
{% include source_path + "hello." + language_ %}
{% endhighlight %}
  </section>

  <section>
    <h3>Comments</h3>
{% highlight language_ %}
// single line comment
int x = 5;  // comments can be added at the end of a line

/*
 * multiline comment
 * ...
 */
{% endhighlight %}
    <div class="fragment">
      <p>Removed by the preprocessor</p>
    </div>
  </section>

  <section>
    <h3>Main Function</h3>
    <p>Serves a special purpose in {{ language }} programs:<br />
      program execution begins with <code>main(.)</code></p>
{% highlight language_ + " 3-6" %}
{% include source_path + "hello." + language_ %}
{% endhighlight %}
  </section>

  <section>
    <h3>Return Value</h3>
    <p>Indicate success (<code>0</code>) or a failure code to the calling
      operating system shell</p>
{% highlight language_ + " 5" %}
{% include source_path + "hello." + language_ %}
{% endhighlight %}
  </section>
</section>

{# TODO: extend this presentation to include
- data types
- Variable, Assignment
- printf / cout with format specifiers
- ...

 #}

<section>
  <h2>Compiling and Executing a {{ language }} Program</h2>

  <section>
    <p>For creating executables, a compiler toolchain is needed.</p>
    <ul>
      <li><a href="http://gcc.gnu.org/">GCC</a> - GNU Compiler Collection,
        GCC</li>
      <li><a href="https://clang.llvm.org/">Clang</a> - C language family
        frontend for LLVM</li>
      <li>MSVC - Microsoft Visual C and C++ compiler</li>
    </ul>
  </section>

  <section>
    <p>
      Creating a C executable is a four step process.
    </p>
    <ol>
      <li>Preprocessor</li>
      <li>Compiler</li>
      <li>Assembler</li>
      <li>Linker</li>
    </ol>
  </section>

  <section>
    <h3>Example</h3>
      <p>{% download "/data/" + language_ + "/hello." + language_ %}</p>
      <p>By default, all four stages (preprocessor, compiler, assembler
        and linker)<br />are done</p>
{% highlight "bash" %}
{{ compiler }} hello.{{ language_ }}  # or `{{ alt_compiler }} hello.{{ language_ }}`
./a.out
{% endhighlight %}
      <div class="fragment">
      <p>Provide a name for the created executable (instead of the default
        <code>a.out</code>
      </p>
{% highlight "bash" %}
{{ compiler }} hello.{{ language_}} -o hello
./hello
{% endhighlight %}
      <dev class="fragment">
        <p>Compilation can be done with either <code>{{ compiler }}</code> or
          <code>{{ alt_compiler }}</code>.</p>
{% highlight "bash" %}
{{ compiler }} $INFILE -o $PROGRAM_NAME
{{ alt_compiler }} $INFILE -o $PROGRAM_NAME
{% endhighlight %}
      </dev>
</div>
  </section>

  <section>
    <h3>1. Preprocessor</h3>
    <ul>
      <li>Essentially a pure text processor</li>
      <li>Removes comments, perform includes etc.</li>
      <li>Usually never done separately</li>
    </ul>
    <div class="fragment">
      <p>Stop after preprocessor and send output to <code>stdout</code></p>
{% highlight "bash" %}
{{ compiler }} -E hello.{{ language_}}
{% endhighlight %}
    </div>
  </section>

  <section>
    <h3>2. Compiler</h3>
    <ul>
      <li>Translates high level code to a lower level (assembly language)</li>
      <li>Parses the source code</li>
      <li>Performs type checking</li>
      <li>Usually never done separately</li>
    </ul>
    <div class="fragment">
      <p>Creates assembler files (usually <code>*.s</code>)</p>
{% highlight "bash" %}
{{ compiler }} -S hello.{{ language_}}
{% endhighlight %}
    </div>
  </section>

  <section>
    <h3>3. Assembler</h3>
    <ul>
      <li>Translates assembly language to object code (machine language)</li>
      <li>Creates <code>*.o</code> files</li>
      <li><strong>Usually done separately</strong> when working with multiple input files
        <ul class="fragment">
          <li>Impossible to create executables without <code>main(.)</code></li>
          <li>Impossible to create executables with multiple <code>main(.)</code></li>
        </ul>
      </li>
    </ul>
    <div class="fragment">
{% highlight "bash" %}
{{ compiler }} -c hello.{{ language_}}
{% endhighlight %}
    </div>
  </section>

  <section>
    <h3>4. Linker</h3>
    <ul>
      <li>Combines object files into a unified executable program, resolving all symbols</li>
      <li><strong>Has to be run separately</strong> when working with multiple input files</li>
    </ul>
    <div class="fragment">
{% highlight "bash" %}
{{ compiler }} -o hello hello.o
{% endhighlight %}
    </div>
  </section>
</section>

{% include 'slides/closing.njk' %}
{% endblock %}
